' Vorteiler 10:1 für einen Ereigniszaehler 0 - 999999
' Compiler: BASCOM 2.0.7.5 Demo
' Gezaehlt werden positive Flanken an PinB.1
' nach 10 Impulsen wechselt PortB.4 entweder fuer 10 msec auf High (auskommentiert)
' oder wird erst bei der nächsten Flanke high -> low zurückgestellt (aktiv)


$regfile = "Attiny13.dat"
$crystal = 1200000
$hwstack = 32
$swstack = 8
$framesize = 8

DDRB =  &B00010000                                         ' nur PortB.4 ist Ausgang
DIDR0 = &B00011101                                         ' Digitaleingaenge bis auf PinB.1 deaktiviert
GIMSK.PCIE = 1                                             ' Pin Change Interrupt PortB aktiviert
PCMSK.PCINT1 = 1                                           ' nur Bit 1 (PinB..1) wird durchgelassen
SREG.7 = 1                                                 ' enable Interrupts

Dim I As Byte
Dim M As Byte

Const Overflow = 10                                       ' ggf. 100 fuer Teilerverhaeltnis 1:100


Do

   If PinB.1 = 1 Then
       If M = 0 Then                                      ' M verhindert mehrfache Inkrmentierungen von I
           Incr I
           M = 1
       End If
       If I >= Overflow Then
           PortB.4 = 1
           I = 0
'           Waitms 10                                      ' PortB.4 10 msec auf high, dann wieder low
'           PortB.4 = 0
       End If
'       Waitms 1                                           ' ggf. gegen Kontaktprellen am Eingang
       Powerdown
   End If

   If Pinb.1 = 0 Then
       PortB.4 = 0                                          ' Rueckstellen von PortB.4 erst bei high-low-Flanke
       M = 0
       Powerdown
   End If
Loop

End
